2024-06-21, Jim Sauer ([@\_jims](https://forum.keyboardmaestro.com/u/_jims/activity))

# Desktop Spaces • Macros to Improve Navigation and Window Management, v3.0

[WhichSpace](https://github.com/gechr/WhichSpace/blob/master/README.md) provides two functions:

1. Displays the [Desktop Space](https://support.apple.com/guide/mac-help/work-in-multiple-spaces-mh14112/mac) number in the [macOS menu bar](https://support.apple.com/guide/mac-help/whats-in-the-menu-bar-mchlp1446/mac). This is a nice feature, but technically not required to use this macro group. 

2. Provides the capability to retrieve the current [Desktop Space](https://support.apple.com/guide/mac-help/work-in-multiple-spaces-mh14112/mac) number via [AppleScript](https://developer.apple.com/library/archive/documentation/AppleScript/Conceptual/AppleScriptLangGuide/introduction/ASLR_intro.html). This is required to use this macro group and done in macro **sub—Get DesktopNo**.

## Installation

Double-click **WhichSpace – Download Latest Release.webloc** to install this free, open-source application.

## Alternate Installation

If you prefer to install **WhichSpace** using [HomeBrew](https://brew.sh/), open [Terminal](https://support.apple.com/guide/terminal/welcome/mac) and run the following command:

```sh
brew install --cask whichspace
```

## Open WhichSpace During Each Login

Regardless of the installation method, set **WhichSpace** to [open (start) during each login](https://support.apple.com/guide/mac-help/open-items-automatically-when-you-log-in-mh15189/mac).

## Desktop Space Number Appearance With macOS Sonoma

With **WhichSpace 0.3.2**, the menu bar icon is slightly misaligned under macOS Sonoma. This [cosmetic issue](https://github.com/gechr/WhichSpace/issues/33) does not effect the function of this macro group.