2024-10-21, Jim Sauer ([@_jims](https://forum.keyboardmaestro.com/u/_jims/activity))

# Desktop Spaces • Macros to Improve Navigation and Window Management, v4.0

## Keyboard Maestro Version 11+

As of **Version 2.0+ (2023-10-27)**, these macros require Keyboard Maestro **Version 11+**.


## Deleting Previous Versions

> Note: It is very important to delete older versions of these macros before completing the installation of **Version 3.0**.

If you previously installed any macros from the Keyboard Maestro forum threads [Desktop Spaces • Macros for Navigation and Window Management](https://forum.keyboardmaestro.com/t/macros-desktop-spaces-macros-for-navigation-and-window-management-v1-1/21507) or [Desktop Spaces • Macros to Improve Navigation and Window Management](https://forum.keyboardmaestro.com/t/macros-desktop-spaces-macros-to-improve-navigation-and-window-management-v1-1/27033), complete the following steps:

1. For the **:sys Desktop Spaces** macro group, rename it **:sys Desktop Spaces-superseded**. For the renamed group **export** it, then **delete** it.

2. For the **.sys Spaces** macro group, rename it **.sys Spaces-superseded**. For the renamed group **export** it, then **delete** it.

3. For the **.sys Desktops** macro group, rename it **.sys Desktops-superseded**. For the renamed group **export** it, then **delete** it.

4. For the **.sys Desktop Spaces** macro group, rename it **.sys Desktop Spaces-superseded**. For the renamed group **export** it, then **delete** it.

> In the unlikely event that it becomes necessary to view the macros deleted above, the exported groups can be imported, but only after installing **Version 4.0** below.

## Installation

> Note:  **Version 4.0** installs the macros in a group named **⋮sys Desktop Spaces**. This has been the case since **Version 3.0**; older versions installed in groups that started with a dot (`.`)

1. Confirm that Keyboard Maestro **Version 11+** is installed.

2. A few macOS **Preferences** (or **Settings** for Ventura+) must be set to enable proper operation of this macro group. For instructions, please refer to the [Keyboard Maestro Forum](https://forum.keyboardmaestro.com), specifically the thread [Desktop Spaces • Macros to Improve Navigation and Window Management](https://forum.keyboardmaestro.com/t/macros-desktop-spaces-macros-to-improve-navigation-and-window-management-v1-1/27033).

3. Open the **1 - WhichSpace** folder, and follow the instructions in **\_READ ME FIRST\_.pdf**.

4. Open the **2 - Keyboard Maestro Macros** folder, and follow the instructions in **\_READ ME FIRST\_.pdf**.

## Version History

### v4.0 (2024-10-21) • Requires Keyboard Maestro Version 11+

### Summary of Improvements

  * Hot key changes were made to macros **Go to Previous Desktop** and **Move Window to Previous Desktop** necessitated by [macOS Sequoia](https://www.apple.com/macos/macos-sequoia/) that uses the Keyboard Shortcut **⌃Return** to display contextual menus. For more information, see [50 New macOS Sequoia Features and Changes Worth Checking Out - MacRumors](https://www.macrumors.com/guide/50-new-macos-sequoia-features-and-changes/#:~:text=46) (#46).
  
  * The macro palette (which is optional to use) was updated to reflect the hot key changes noted above.
  
  * Bug fix: In **sub—Go to Desktop N** changed [Cancel Just This Macro](https://wiki.keyboardmaestro.com/actions/Redirect_Control_Flow) to [Return Result](https://wiki.keyboardmaestro.com/action/Return_Result). For more information, see ["Cancel Just This Macro" in a Subroutine](https://forum.keyboardmaestro.com/t/38049).

macro: **Go Right a Desktop**

  * Modified the logic such that **sub—Put DesktopNo and/or DesktopNo\_prev** is not run if there is an attempt to move beyond the rightmost desktop.
  
macro: **Go to Previous Desktop**

  * Changed both triggers: a) **⌃Return** changed to **⌃⌥Return**; b) **⌃⌥Return** changed to **⌃⌘Return**. This was necessitated by [macOS Sequoia](https://www.apple.com/macos/macos-sequoia/) that uses the Keyboard Shortcut **⌃Return** to display contextual menus. For more information, see [50 New macOS Sequoia Features and Changes Worth Checking Out - MacRumors](https://www.macrumors.com/guide/50-new-macos-sequoia-features-and-changes/#:~:text=46) (#46).
  
macro: **Move Window to Previous Desktop**

  * Changed trigger from **⌃⌘Return** to **⌃⌥⌘Return**. This was necessitated by trigger changes to **Go to Previous Desktop** that were in turn necessitated by [macOS Sequoia](https://www.apple.com/macos/macos-sequoia/) that uses the Keyboard Shortcut **⌃Return** to display contextual menus. For more information, see [50 New macOS Sequoia Features and Changes Worth Checking Out - MacRumors](https://www.macrumors.com/guide/50-new-macos-sequoia-features-and-changes/#:~:text=46) (#46).

macro: **sub—Go to Desktop N**

  * Bug fix: Changed [Cancel Just This Macro](https://wiki.keyboardmaestro.com/actions/Redirect_Control_Flow) to [Return Result](https://wiki.keyboardmaestro.com/action/Return_Result). For more information see ["Cancel Just This Macro" in a Subroutine](https://forum.keyboardmaestro.com/t/38049).

macro: **sub—Type Keystroke for Switch to Desktop N** 

  * In the Switch/Case action, changed the condition **>= 16** back to **>= 16**.

  * Enabled **Returning a value** and return **0** if a **local\_DesktopNo** is a value that is not configured.

macro: **20)Previous   ⌃⌥↩**

  * Renamed from **20)Previous   ⌃↩**

macro: **43)to Previous [^+click]   ⌃⌥⌘↩ [2t]**

  * Renamed from **43)to Previous [^+click]   ⌃⌘↩ [2t]**

### v3.0 (2024-06-21) • Requires Keyboard Maestro Version 11+

### Summary of Improvements

  * Macros **Go Left a Desktop** (& **Move Window Left a Desktop**) and **Go Right a Desktop** (& **Move Window Right a Desktop**) have been improved:
  
    * While holding the modifier (default **Control** ⌃), if the **right arrow** or **left arrow** are tapped, the display is moved *directly* that many Desktop Spaces. For example, if you are viewing **Desktop 4** and press and hold **Control** and tap the **right arrow** three times, the display will be moved directly to **Desktop 7**.
  
    * In contrast, while holding the modifier, if the **right** or **left arrows** are held down, the display will be moved *right* (or *left*) until the arrow key is released. In this case, all Desktops between the starting point and the ending point will be briefly visible. This method is likely useful if you are searching for a particular window as you are moving through the Desktops.
    
    * Optionally, when moving a display and window, the display can be returned to the original Desktop Space. Two methods can be used to achieve this optional behavior:

        1. via **hotkey**: hold down the modifier keys and tap the hotkey integer *twice*.

        2. via the Desktop Spaces **palette**: when clicking the palette item, hold down the **Control** (⌃) key.
    
  * With some limitations, the macro set can now be used without [WhichSpace ](https://github.com/gechr/WhichSpace). If it is not installed and running, the Desktop Space Number will not be visible in the macOS menubar. Also, tracking of the *current* and *previous* Desktop will be temporarily inaccurate if a Desktop change occurs outside the control of these macros. For example:

    * three-finger swipe left or right on a trackpad

    * [Mission Control Desktop Spaces](https://support.apple.com/guide/mac-help/work-in-multiple-spaces-mh14112/mac) is displayed and a Desktop is selected

    * a macOS application is opened, or activated, and an automatic Desktop change occurs

  * The Desktop Space palette has been annotated to indicate items that can be optionally Control (⌃)+clicked and hotkeys that can be tapped twice [2t] or multiple times [mt].

  * Version 3.0 of this macro group includes other improvements detailed below.



macro: **Go Left a Desktop**

  * Completely rewritten to provide the features described above.
  
  * Added logic to allow this macro set to run without [WhichSpace ](https://github.com/gechr/WhichSpace) running, albeit with some limitations.



macro: **Go Right a Desktop**

  * Completely rewritten to provide the features described above.
  
  * Added logic to allow this macro set to run without [WhichSpace ](https://github.com/gechr/WhichSpace) running, albeit with some limitations.



macro: **Go to Application Desktop** 

  * Added logic to allow this macro set to run without [WhichSpace ](https://github.com/gechr/WhichSpace) running, albeit with some limitations.


macro: **Go to Previous Desktop** 

  *  Added logic to allow this macro set to run without [WhichSpace ](https://github.com/gechr/WhichSpace) running, albeit with some limitations.



macro: **Move Application Window to Current Desktop** 

  * Removed the unnecessary [Semaphore Lock](https://wiki.keyboardmaestro.com/action/Semaphore_Lock).



macro: **Move Window Left a Desktop** 

  * Completely rewritten to provide the features described above.

  * Added logic to allow this macro set to run without [WhichSpace ](https://github.com/gechr/WhichSpace) running, albeit with some limitations.



macro: **Move Window Right a Desktop** 

  * Completely rewritten to provide the features described in the PURPOSE.

  * Added logic to allow this macro set to run without [WhichSpace ](https://github.com/gechr/WhichSpace) running, albeit with some limitations.



macro: **Move Window to Previous Desktop** 

  * Added logic to optionally return to the original Desktop Space.



macro: **sub—Activate an App and Wait Until It Is Ready** 

  * Deselected *Returning* a value since it was not being used.



macro: **sub—Get DesktopNo** 

  * Added condition to set to -1 if no valid value is retrieved from the dictionary. This handles rare, but possible boundary conditions.
  
  * Added logic to allow this macro set to run without [WhichSpace ](https://github.com/gechr/WhichSpace) running, albeit with some limitations.



macro: **sub—Get DesktopNo_prev** 

  * Added condition to set to -1 if no valid value is retrieved from the dictionary. This handles rare, but possible boundary conditions.



macro: **sub—Go to Desktop N** 

  * Added logic to allow this macro set to run without [WhichSpace ](https://github.com/gechr/WhichSpace) running, albeit with some limitations.
  
  * Reduced execution time by removing a hard-coded pause.
  
  * Deselected *Returning a value* since it was not being used.



macro: **sub—Move Window to Desktop N** 

  * Added logic to optionally return to the original Desktop Space.
  
  * Deselected *Returning a value* since it was not being used.
  
  
  
macro: **sub—Put DesktopNo and/or DesktopNo_prev**

  * Simplified the conditional logic since **sub—Get DesktopNo** and **sub—Get DesktopNo_prev** were modified to set the value to -1 if no valid value is found.
  
  * Deselected *Returning a value* since it was not being used.



macro: **sub—Type Keystroke for Switch to Desktop N** 

  * In the Switch/Case action, changed the condition **= 1** to **<= 1**.

  * In the Switch/Case action, changed the condition **= 16** to **>= 16**.
  
  * Updated the header comment with updated instructions.
  


macro: **01)⎯⎯⎯⎯⎯ [ go to Desktop Space ] ⎯⎯⎯⎯⎯**

  * The macro serves as the left header for the macro set palette. If this header is inadvertently clicked, the macro now properly causes the palette to reappear. From the user's standpoint, this entry now behaves as if it is static text. In Version 2.0, the palette would dismiss.



macro: **24)⎯⎯⎯⎯⎯⎯ [ move Window ] ⎯⎯⎯⎯⎯⎯**

  * The macro serves as the right header for the macro set palette. If this header is inadvertently clicked, the macro now properly causes the palette to reappear. From the user's standpoint, this entry now behaves as if it is static text. In Version 2.0, the palette would dismiss.
  
  
Added palette macros:

  * **22)┈┈┈┈┈┈┈┈┈┈┈┈┈┈┈┈┈┈┈┈┈**
  * **23)[ ] == optional; mt == multiple taps**
  * **45)┈┈┈┈┈┈┈┈┈┈┈┈┈┈┈┈┈┈┈┈┈**
  * **46)^+click or 2 taps of hot key returns to Space**


### v2.0 (2023-10-27) • Requires Keyboard Maestro Version 11+

### Summary of Improvements

  * Forty-three of the fifty-eight macros in this macro group are included in a palette. This palette is displayed using one of the macros in this group, **➜ Desktop Spaces - Show Palette of Macros**, that includes a **Show Palette of Macros** action. By default, the palette can be displayed using **⌃D**. Keyboard Maestro Version 11 provides a new feature that allows such palette to have an individual style. This feature has been used to optimize the appearance of the palette for this macro group. Previously the much less flexible **Conflict Palette** was used.
  
  * The macro **Go to Previous Desktop** uses a new Keyboard Maestro Version 11+ trigger **When the active space changes**. This new trigger enables more robust tracking of [Desktop Space](https://support.apple.com/guide/mac-help/work-in-multiple-spaces-mh14112/mac) changes that are not keyboard-driven (i.e., via [trackpad gestures](https://support.apple.com/en-us/102482#:~:text=Swipe%20between%20full%2Dscreen%20apps,desktops%20and%20full%2Dscreen%20apps.) or [Mission Control interaction](https://support.apple.com/guide/mac-help/open-windows-spaces-mission-control-mh35798/mac)). Previously the **The focused window changes** was used; it didn't always fire when needed and fired many times when it was not needed.
  
  * Version 2.0 of this macro group includes many other improvements detailed below.

macro: **Go to Application Desktop** 

  * Added a **Title** to the Prompt With List

macro: **Go to Previous Desktop** 

  * Uses the new Keyboard Maestro Version 11+ trigger: **When the active space changes** (replacing the **The focused window changes**).
  * Changed ⌃⌥Return to display the Previous Desktop Space in **large text** (replacing a notification).
  * Added option to generate a sound when the space is changed. Note that the volume can be changed or the action can be disabled.

macro: **Move Application Window to Current Desktop** 

  * The click-and-hold is done using **absolute position** because, during testing, it was found that with some applications **front window *top-left* corner** did not work as expected. Note: Thus far, this does not seem to be an issue if the application is already in the active Desktop Space, therefore the **absolute position** adjustment has not been made in macros: **Move Window Left**, **Move Window Right**, and **Move Window to Previous Desktop**.
  * For the Pause after the click-and-hold, changed from 0.2 to 0.5; for the Pause before the mouse release, changed from 1.0 to 1.5.

macro: **Move Window Left a Desktop** 

  * For the Pause after the click-and-hold, changed from 0.2 to 0.5; for the Pause before the mouse release, changed from 1.0 to 1.5.

macro: **Move Window Right a Desktop** 

  * For the Pause after the click-and-hold, changed from 0.2 to 0.5; for the Pause before the mouse release, changed from 1.0 to 1.5.

macro: **Move Window to Previous Desktop** 

  * For the Pause after the click-and-hold, changed from 0.2 to 0.5; for the Pause before the mouse release, changed from 1.0 to 1.5.

macro: **sub—Activate an App and Wait Until It Is Ready** 

  * Removed the Front Window Check and the corresponding variable **local_Null FrontWindowName**.
  * When an **About** menu is not found, a dialog is generated (replacing a notification). The dialog includes an **Edit** button which enables a quick method to open this subroutine so that the application can be added to the **local_MissingAboutMenuItem** variable.

macro: **sub—Get DesktopNo** 

  * Removed the **local__Notification Level** subroutine parameter as it is no longer needed since macro **Go to Previous Desktop** was changed to use Keyboard Maestro Version 11+ trigger **When the active space changes** (replacing trigger **The focused window changes**).
  * Moved the **WhichSpace** AppleScript to a Until action (Timeout set to 5 seconds). The approach previously was to run the AppleScript and then Pause 0.2 seconds.
  * If **WhichSpace** is not running, added a check that the user has been logged in for at least 2 minutes so that the WhichSpace *not running* dialog does not appear during mac boot up or user login.

macro: **sub—Get DesktopNo_prev** 

  * Removed the parameter **local__DefaultDesktopNo_prev**.

macro: **sub—Go to Desktop N** 

  * When attempting to move to a Desktop Space that does not exist, alert using **large text** (replacing a notification).

macro: **sub—Move Window to Desktop N** 

  * Takes no action if **local__TargetDesktopNo** matches the curent DesktopNo.
  * For the Pause after the click-and-hold, changed from 0.2 to 0.5; for the Pause before the mouse release changed from 1.0 to 1.5.

macro: **sub—Type Keystroke for Switch to Desktop N** 

  * Removed the *otherwise* notification since a failure to move to a non-existent Desktop Space is handled in the macro **sub—Go to Desktop N**.  

### v1.1 (2022-04-06) • Requires Keyboard Maestro Version 10+

macro: **Go to Previous Desktop**

  * Bug fix: **local_dnPreviouslySaved** was improperly determined.

macro: **Move Window to Previous Desktop**

  * Removed an extraneous **local_dnTarget** Set Variable to Text action. No change to macro functionality.

macro: **sub—Activate an App and Wait Until It Is Ready**

  * Added provision for applications that have a null %FrontWindowName%.

### v1.0 (2022-03-21) Initial version • Requires Keyboard Maestro Version 10+